Index: /code/trunk/src/orxonox/pickup/DroppedItem.h
===================================================================
--- /code/trunk/src/orxonox/pickup/DroppedItem.h	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/DroppedItem.h	(revision 5929)
@@ -77,5 +77,5 @@
         BaseItem* item_;
 
-        Timer<DroppedItem> timer_;
+        Timer timer_;
     };
 }
Index: /code/trunk/src/orxonox/pickup/ModifierPickup.cc
===================================================================
--- /code/trunk/src/orxonox/pickup/ModifierPickup.cc	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/ModifierPickup.cc	(revision 5929)
@@ -101,7 +101,7 @@
             if (this->duration_ > 0.0f)
             {
-                ExecutorMember<ModifierPickup>* executor = createExecutor(createFunctor(&ModifierPickup::timerCallback));
+                Executor* executor = createExecutor(createFunctor(&ModifierPickup::timerCallback, this));
                 executor->setDefaultValues(pawn);
-                this->timer_.setTimer(this->duration_, false, this, executor);
+                this->timer_.setTimer(this->duration_, false, executor);
             }
 
@@ -139,5 +139,5 @@
                 this->timer_.stopTimer();
 
-            delete this;
+            this->destroy();
 
             return true;
Index: /code/trunk/src/orxonox/pickup/ModifierPickup.h
===================================================================
--- /code/trunk/src/orxonox/pickup/ModifierPickup.h	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/ModifierPickup.h	(revision 5929)
@@ -129,4 +129,5 @@
 
         void timerCallback(Pawn* pawn);     //!< Method called when the timer runs out.
+        
     private:
         float getAdditiveModifier(ModifierType::Value type) const;               //!< Get the additive modifier for a given ModifierType.
@@ -138,6 +139,6 @@
         std::map<ModifierType::Value, float> multiplicativeModifiers_;           //!< Map of multiplicative modifiers, indexed by ModifierType.
 
-        float duration_;                                                        //!< Duration of this pickup's effect (0 for unlimited).
-        Timer<ModifierPickup> timer_;                                           //!< Timer used if the pickup's effect has a time limit.
+        float duration_;                                                         //!< Duration of this pickup's effect (0 for unlimited).
+        Timer timer_;                                                            //!< Timer used if the pickup's effect has a time limit.
     };
 }
Index: /code/trunk/src/orxonox/pickup/PickupSpawner.cc
===================================================================
--- /code/trunk/src/orxonox/pickup/PickupSpawner.cc	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/PickupSpawner.cc	(revision 5929)
@@ -91,5 +91,5 @@
             asItem->addTemplate(this->itemTemplate_);
             PickupInventory::getImageForItem(asItem);
-            delete newObject;
+            newObject->destroy();
         }
 
@@ -127,5 +127,5 @@
         if (this->isActive())
         {
-            for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); it++)
+            for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); ++it)
             {
                 Vector3 distance = it->getWorldPosition() - this->getWorldPosition();
@@ -166,6 +166,5 @@
                     if (this->respawnTime_ > 0.0f)
                     {
-                        ExecutorMember<PickupSpawner>* executor = createExecutor(createFunctor(&PickupSpawner::respawnTimerCallback));
-                        this->respawnTimer_.setTimer(this->respawnTime_, false, this, executor);
+                        this->respawnTimer_.setTimer(this->respawnTime_, false, createExecutor(createFunctor(&PickupSpawner::respawnTimerCallback, this)));
 
                         this->setActive(false);
@@ -174,5 +173,5 @@
                 }
                 else
-                    delete newObject;
+                    newObject->destroy();
             }
         }
Index: /code/trunk/src/orxonox/pickup/PickupSpawner.h
===================================================================
--- /code/trunk/src/orxonox/pickup/PickupSpawner.h	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/PickupSpawner.h	(revision 5929)
@@ -114,5 +114,5 @@
 
         float respawnTime_;                     //!< Time after which this gets re-actived.
-        Timer<PickupSpawner> respawnTimer_;     //!< Timer used for re-activating.
+        Timer respawnTimer_;                    //!< Timer used for re-activating.
     };
 }
Index: /code/trunk/src/orxonox/pickup/items/HealthImmediate.cc
===================================================================
--- /code/trunk/src/orxonox/pickup/items/HealthImmediate.cc	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/items/HealthImmediate.cc	(revision 5929)
@@ -67,5 +67,5 @@
         {
             pawn->addHealth(this->recoveredHealth_);
-            delete this;
+            this->destroy();
         }
 
Index: /code/trunk/src/orxonox/pickup/items/HealthUsable.cc
===================================================================
--- /code/trunk/src/orxonox/pickup/items/HealthUsable.cc	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/items/HealthUsable.cc	(revision 5929)
@@ -82,5 +82,5 @@
 
             this->removeFrom(pawn);
-            delete this;
+            this->destroy();
         }
     }
Index: /code/trunk/src/orxonox/pickup/items/Jump.cc
===================================================================
--- /code/trunk/src/orxonox/pickup/items/Jump.cc	(revision 5928)
+++ /code/trunk/src/orxonox/pickup/items/Jump.cc	(revision 5929)
@@ -84,5 +84,5 @@
         {
             this->removeFrom(pawn);
-            delete this;
+            this->destroy();
         }
     }
Index: /code/trunk/src/orxonox/sound/AmbientSound.cc
===================================================================
--- /code/trunk/src/orxonox/sound/AmbientSound.cc	(revision 5929)
+++ /code/trunk/src/orxonox/sound/AmbientSound.cc	(revision 5929)
@@ -0,0 +1,62 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "AmbientSound.h"
+
+#include "core/CoreIncludes.h"
+#include "core/EventIncludes.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    CreateFactory(AmbientSound);
+
+    AmbientSound::AmbientSound(BaseObject* creator)
+        : BaseObject(creator)
+    {
+        RegisterObject(AmbientSound);
+    }
+
+    AmbientSound::~AmbientSound()
+    {
+    }
+
+    void AmbientSound::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(AmbientSound, XMLPort, xmlelement, mode);
+        XMLPortParamExtern(AmbientSound, BaseSound, this, "source", setSource, getSource, xmlelement, mode);
+        XMLPortParamExtern(AmbientSound, BaseSound, this, "loop", setLoop, getLoop, xmlelement, mode);
+        XMLPortParamExtern(AmbientSound, BaseSound, this, "playOnLoad", setPlayOnLoad, getPlayOnLoad, xmlelement, mode);
+    }
+
+    void AmbientSound::XMLEventPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(AmbientSound, XMLEventPort, xmlelement, mode);
+        XMLPortEventState(AmbientSound, BaseObject, "play", play, xmlelement, mode);
+    }
+}
Index: /code/trunk/src/orxonox/sound/AmbientSound.h
===================================================================
--- /code/trunk/src/orxonox/sound/AmbientSound.h	(revision 5929)
+++ /code/trunk/src/orxonox/sound/AmbientSound.h	(revision 5929)
@@ -0,0 +1,56 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+#ifndef _AmbientSound_H__
+#define _AmbientSound_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include "core/BaseObject.h"
+#include "sound/BaseSound.h"
+
+namespace orxonox
+{
+    /**
+     * The AmbientSound class is the base class for all sound file loader classes.
+     * It server as main interface to the OpenAL library.
+     *
+     */
+    class _OrxonoxExport AmbientSound : public BaseSound, public BaseObject
+    {
+    public:
+        AmbientSound(BaseObject* creator);
+        virtual ~AmbientSound();
+
+        virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+        virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
+
+    private:
+    };
+}
+
+#endif /* _AmbientSound_H__ */
Index: /code/trunk/src/orxonox/sound/BaseSound.cc
===================================================================
--- /code/trunk/src/orxonox/sound/BaseSound.cc	(revision 5929)
+++ /code/trunk/src/orxonox/sound/BaseSound.cc	(revision 5929)
@@ -0,0 +1,262 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Erwin 'vaiursch' Herrsche
+ *   Co-authors:
+ *      Reto Grieder
+ *
+ */
+
+#include "BaseSound.h"
+
+#include <vector>
+#include <AL/alut.h>
+#include <vorbis/vorbisfile.h>
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+#include "core/Resource.h"
+
+namespace orxonox
+{
+    BaseSound::BaseSound()
+        : audioSource_(0)
+        , audioBuffer_(0)
+        , bPlayOnLoad_(false)
+        , bLoop_(false)
+    {
+        RegisterRootObject(BaseSound);
+    }
+
+    BaseSound::~BaseSound()
+    {
+        this->setSource("");
+    }
+
+    void BaseSound::play()
+    {
+        if (alIsSource(this->audioSource_))
+        {
+            if (this->bLoop_)
+                alSourcei(this->audioSource_, AL_LOOPING, AL_TRUE);
+            else
+                alSourcei(this->audioSource_, AL_LOOPING, AL_FALSE);
+            alSourcePlay(this->audioSource_);
+
+            if (alGetError() != AL_NO_ERROR)
+            {
+                 COUT(2) << "Sound: OpenAL: Error playin sound " << this->audioSource_ << std::endl;
+            }
+        }
+    }
+
+    void BaseSound::stop()
+    {
+        if (alIsSource(this->audioSource_))
+            alSourceStop(this->audioSource_);
+    }
+
+    void BaseSound::pause()
+    {
+        if (alIsSource(this->audioSource_))
+            alSourcePause(this->audioSource_);
+    }
+
+    bool BaseSound::isPlaying()
+    {
+        if (alIsSource(this->audioSource_))
+            return getSourceState() == AL_PLAYING;
+        return false;
+    }
+
+    bool BaseSound::isPaused()
+    {
+        if (alIsSource(this->audioSource_))
+            return getSourceState() == AL_PAUSED;
+        return true;
+    }
+
+    bool BaseSound::isStopped()
+    {
+        if (alIsSource(this->audioSource_))
+            return getSourceState() == AL_INITIAL || getSourceState() == AL_STOPPED;
+        return true;
+    }
+
+    void BaseSound::setPlayOnLoad(bool val)
+    {
+        this->bPlayOnLoad_ = true;
+        this->play();
+    }
+
+    void BaseSound::setSource(const std::string& source)
+    {
+        this->source_ = source;
+        if (!GameMode::playsSound())
+            return;
+
+        if (source.empty() && alIsSource(this->audioSource_))
+        {
+            // Unload sound
+            alSourcei(this->audioSource_, AL_BUFFER, 0);
+            alDeleteSources(1, &this->audioSource_);
+            alDeleteBuffers(1, &this->audioBuffer_);
+            return;
+        }
+
+        COUT(3) << "Sound: OpenAL ALUT: loading file " << source << std::endl;
+        // Get DataStream from the resources
+        shared_ptr<ResourceInfo> fileInfo = Resource::getInfo(source);
+        if (fileInfo == NULL)
+        {
+            COUT(2) << "Warning: Sound file '" << source << "' not found" << std::endl;
+            return;
+        }
+        dataStream_ = Resource::open(source);
+        // Read everything into a temporary buffer
+        char* buffer = new char[fileInfo->size];
+        dataStream_->read(buffer, fileInfo->size);
+        dataStream_->seek(0);
+
+        this->audioBuffer_ = alutCreateBufferFromFileImage(buffer, fileInfo->size);
+        delete[] buffer;
+
+        if (this->audioBuffer_ == AL_NONE)
+        {
+            COUT(2) << "Sound: OpenAL ALUT: " << alutGetErrorString(alutGetError()) << std::endl;
+            if (source.find("ogg", 0) != std::string::npos)
+            {
+                COUT(2) << "Sound: Trying fallback ogg loader" << std::endl;
+                this->audioBuffer_ = loadOggFile();
+            }
+
+            if (this->audioBuffer_ == AL_NONE)
+            {
+                COUT(2) << "Sound: fallback ogg loader failed: " << alutGetErrorString(alutGetError()) << std::endl;
+                return;
+            }
+        }
+
+        alGenSources(1, &this->audioSource_);
+        alSourcei(this->audioSource_, AL_BUFFER, this->audioBuffer_);
+        if (alGetError() != AL_NO_ERROR)
+        {
+            COUT(2) << "Sound: OpenAL: Error loading sample file: " << source << std::endl;
+            return;
+        }
+
+        alSource3f(this->audioSource_, AL_POSITION,  0, 0, 0);
+
+        if (this->bPlayOnLoad_)
+            this->play();
+    }
+
+    ALint BaseSound::getSourceState()
+    {
+        ALint state;
+        alGetSourcei(this->audioSource_, AL_SOURCE_STATE, &state);
+        return state;
+    }
+
+    size_t readVorbis(void* ptr, size_t size, size_t nmemb, void* datasource)
+    {
+        return static_cast<Ogre::DataStream*>(datasource)->read(ptr, size * nmemb);
+    }
+
+    int seekVorbis(void* datasource, ogg_int64_t offset, int whence)
+    {
+        Ogre::DataStream* stream = static_cast<Ogre::DataStream*>(datasource);
+        int offset_beg = offset;
+        if (whence == SEEK_CUR)
+            offset_beg = stream->tell() + offset;
+        else if (whence == SEEK_END)
+            offset_beg = stream->size() + offset;
+        else if (whence != SEEK_SET)
+            return -1;
+        stream->seek(offset_beg);
+        return 0;
+    }
+
+    long tellVorbis(void* datasource)
+    {
+        return static_cast<long>(static_cast<Ogre::DataStream*>(datasource)->tell());
+    }
+
+    ALuint BaseSound::loadOggFile()
+    {
+        char inbuffer[4096];
+        std::vector<char> outbuffer;
+        OggVorbis_File vf;
+        vorbis_info* vorbisInfo;
+        int eof = false;
+        int current_section;
+        ALuint buffer;
+        ALenum format;
+
+        // Open file with custom streaming
+        ov_callbacks vorbisCallbacks;
+        vorbisCallbacks.read_func  = &readVorbis;
+        vorbisCallbacks.seek_func  = &seekVorbis;
+        vorbisCallbacks.tell_func  = &tellVorbis;
+        vorbisCallbacks.close_func = NULL;
+
+        int ret = ov_open_callbacks(dataStream_.get(), &vf, NULL, 0, vorbisCallbacks);
+        if (ret < 0)
+        {
+            COUT(2) << "Sound: libvorbisfile: File does not seem to be an Ogg Vorbis bitstream" << std::endl;
+            ov_clear(&vf);
+            return AL_NONE;
+        }
+
+        while (!eof)
+        {
+            long ret = ov_read(&vf, inbuffer, sizeof(inbuffer), 0, 2, 1, &current_section);
+            if (ret == 0)
+            {
+                eof = true;
+            }
+            else if (ret < 0)
+            {
+                COUT(2) << "Sound: libvorbisfile: error reading the file" << std::endl;
+                ov_clear(&vf);
+                return AL_NONE;
+            }
+            else
+            {
+                outbuffer.insert(outbuffer.end(), inbuffer, inbuffer + sizeof(inbuffer));
+            }
+        }
+
+        vorbisInfo = ov_info(&vf, -1);
+        if (vorbisInfo->channels == 1)
+            format = AL_FORMAT_MONO16;
+        else
+            format = AL_FORMAT_STEREO16;
+
+        alGenBuffers(1, &buffer);
+        alBufferData(buffer, format, &outbuffer[0], outbuffer.size(), vorbisInfo->rate);
+        ov_clear(&vf);
+
+        return buffer;
+    }
+
+} // namespace: orxonox
Index: /code/trunk/src/orxonox/sound/BaseSound.h
===================================================================
--- /code/trunk/src/orxonox/sound/BaseSound.h	(revision 5929)
+++ /code/trunk/src/orxonox/sound/BaseSound.h	(revision 5929)
@@ -0,0 +1,83 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Erwin 'vaiursch' Herrsche
+ *   Co-authors:
+ *      Reto Grieder
+ *
+ */
+#ifndef _BaseSound_H__
+#define _BaseSound_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <string>
+#include <OgreSharedPtr.h>
+#include <OgreDataStream.h>
+#include "core/OrxonoxClass.h"
+
+namespace orxonox
+{
+    /**
+     * The BaseSound class is the base class for all sound file loader classes.
+     * It server as main interface to the OpenAL library.
+     *
+     */
+    class _OrxonoxExport BaseSound : virtual public OrxonoxClass
+    {
+    public:
+        BaseSound();
+        virtual ~BaseSound();
+
+        void play();
+        void stop();
+        void pause();
+
+        bool isPlaying();
+        bool isPaused();
+        bool isStopped();
+
+        void setSource(const std::string& source);
+        const std::string& getSource() { return this->source_; }
+
+        bool getPlayOnLoad() { return this->bPlayOnLoad_; }
+        void setPlayOnLoad(bool val);
+
+        bool getLoop() { return this->bLoop_; }
+        void setLoop(bool val) { this->bLoop_ = val; }
+
+    protected:
+        ALuint loadOggFile();
+        ALint getSourceState();
+
+        ALuint audioSource_;
+        ALuint audioBuffer_;
+
+    private:
+        std::string source_;
+        bool bPlayOnLoad_;
+        bool bLoop_;
+        DataStreamPtr dataStream_;
+    };
+}
+
+#endif /* _BaseSound_H__ */
Index: /code/trunk/src/orxonox/sound/CMakeLists.txt
===================================================================
--- /code/trunk/src/orxonox/sound/CMakeLists.txt	(revision 5928)
+++ /code/trunk/src/orxonox/sound/CMakeLists.txt	(revision 5929)
@@ -1,6 +1,7 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+    AmbientSound.cc
+    BaseSound.cc
     SoundManager.cc
-    SoundBase.cc
-    SoundMainMenu.cc
+    WorldSound.cc
 )
 
Index: /code/trunk/src/orxonox/sound/SoundManager.cc
===================================================================
--- /code/trunk/src/orxonox/sound/SoundManager.cc	(revision 5928)
+++ /code/trunk/src/orxonox/sound/SoundManager.cc	(revision 5929)
@@ -31,63 +31,60 @@
 #include <AL/alut.h>
 
+#include "util/Exception.h"
 #include "util/Math.h"
-#include "CameraManager.h"
-#include "graphics/Camera.h"
-#include "SoundBase.h"
+#include "util/ScopeGuard.h"
+#include "core/GameMode.h"
+#include "core/ScopedSingletonManager.h"
 
 namespace orxonox
 {
     SoundManager* SoundManager::singletonPtr_s = NULL;
+    ManageScopedSingleton(SoundManager, ScopeID::Graphics, true);
 
-    /**
-     * Default constructor
-     */
     SoundManager::SoundManager()
     {
-        this->device_ = NULL;
-        this->soundavailable_ = true;
-        if(!alutInitWithoutContext(NULL,NULL))
+        if (!alutInitWithoutContext(NULL,NULL))
+            ThrowException(InitialisationFailed, "OpenAL ALUT error: " << alutGetErrorString(alutGetError()));
+        Loki::ScopeGuard alutExitGuard = Loki::MakeGuard(&alutExit);
+
+        COUT(3) << "OpenAL: Opening sound device..." << std::endl;
+        this->device_ = alcOpenDevice(NULL);
+        if (this->device_ == NULL)
         {
-            COUT(2) << "Sound: OpenAL ALUT: " << alutGetErrorString(alutGetError()) << std::endl;
-            this->soundavailable_ = false;
+            COUT(0) << "OpenaAL: Could not open sound device. Have you installed OpenAL?" << std::endl;
+#ifdef ORXONOX_PLATFORM_WINDOWS
+            COUT(0) << "Just getting the DLL with the dependencies is not enough for Windows (esp. Windows 7)!" << std::endl;
+#endif
+            ThrowException(InitialisationFailed, "OpenAL error: Could not open sound device.");
         }
+        Loki::ScopeGuard closeDeviceGuard = Loki::MakeGuard(&alcCloseDevice, this->device_);
+
+        COUT(3) << "OpenAL: Sound device opened" << std::endl;
+        this->context_ = alcCreateContext(this->device_, NULL);
+        if (this->context_ == NULL)
+            ThrowException(InitialisationFailed, "OpenAL error: Could not create sound context");
+        Loki::ScopeGuard desroyContextGuard = Loki::MakeGuard(&alcDestroyContext, this->context_);
+
+        if (alcMakeContextCurrent(this->context_) == AL_TRUE)
+            COUT(3) << "OpenAL: Context " << this->context_ << " loaded" << std::endl;
+
+        COUT(4) << "Sound: OpenAL ALUT version: " << alutGetMajorVersion() << "." << alutGetMinorVersion() << std::endl;
+
+        const char* str = alutGetMIMETypes(ALUT_LOADER_BUFFER);
+        if (str == NULL)
+            COUT(2) << "OpenAL ALUT error: " << alutGetErrorString(alutGetError()) << std::endl;
         else
-        {
-            assert(this->device_ == NULL);
-            COUT(3) << "Sound: OpenAL: Open sound device..." << std::endl;
-            this->device_ = alcOpenDevice(NULL);
+            COUT(4) << "OpenAL ALUT supported MIME types: " << str << std::endl;
 
-            if(this->device_ == NULL)
-            {
-                COUT(2) << "Sound: OpenAL: Could not open sound device" << std::endl;
-                this->soundavailable_ = false;
-            }
-            else
-            {
-                COUT(3) << "Sound: OpenAL: Sound device opened" << std::endl;
-                this->context_ = alcCreateContext(this->device_, NULL);
-                if(this->context_ == NULL)
-                {
-                    COUT(2) << "Sound: OpenAL: Could not create sound context" << std::endl;
-                    this->soundavailable_ = false;
-                }
-                else
-                {
-                    if(alcMakeContextCurrent(this->context_) == AL_TRUE)
-                        COUT(3) << "Sound: OpenAL: Context " << this->context_ << " loaded" << std::endl;
-
-                    COUT(4) << "Sound: OpenAL ALUT version: " << alutGetMajorVersion() << "." << alutGetMinorVersion() << std::endl;
-                    const char* str = alutGetMIMETypes(ALUT_LOADER_BUFFER);
-                    if (str == NULL)
-                        COUT(2) << "Sound: OpenAL ALUT: " << alutGetErrorString(alutGetError()) << std::endl;
-                    else
-                        COUT(4) << "Sound: OpenAL ALUT supported MIME types: " << str << std::endl;
-                }
-            }
-        }
+        GameMode::setPlaysSound(true);
+        // Disarm guards
+        alutExitGuard.Dismiss();
+        closeDeviceGuard.Dismiss();
+        desroyContextGuard.Dismiss();
     }
 
     SoundManager::~SoundManager()
     {
+        GameMode::setPlaysSound(false);
         alcDestroyContext(this->context_);
         alcCloseDevice(this->device_);
@@ -95,74 +92,25 @@
     }
 
-    /**
-     * Add a SoundBase object to the list. Every SoundBase object should be in
-     * this list.
-     *
-     * @param sound Pointer to the SoundBase object to add
-     */
-    void SoundManager::addSound(SoundBase* sound)
+    void SoundManager::setListenerPosition(const Vector3& position)
     {
-        this->soundlist_.push_back(sound);
+        alListener3f(AL_POSITION, position.x, position.y, position.z);
+        ALenum error = alGetError();
+        if (error == AL_INVALID_VALUE)
+            COUT(2) << "Sound: OpenAL: Invalid listener position" << std::endl;
     }
 
-    /**
-     * Remove a SoundBase object from the list and destroy it.
-     */
-    void SoundManager::removeSound(SoundBase* sound)
+    void SoundManager::setListenerOrientation(const Quaternion& orientation)
     {
-        std::list<SoundBase*>::iterator pos = this->soundlist_.end();
-        for(std::list<SoundBase*>::iterator i = this->soundlist_.begin(); i != this->soundlist_.end(); i++)
-        {
-            if((*i) == sound)
-                pos = i;
-        }
+        // update listener orientation
+        Vector3 up = orientation.xAxis(); // just a wild guess
+        Vector3 at = orientation.zAxis();
 
-        delete (*pos);
-        this->soundlist_.erase(pos);
-    }
+        ALfloat orient[6] = { at.x, at.y, at.z,
+                              up.x, up.y, up.z };
 
-    /**
-     * Tick function, updates listener and registred SoundBase objects
-     *
-     * @param dt @see Orxonox::Tickable
-     */
-    void SoundManager::tick(float dt)
-    {
-        if (!CameraManager::getInstancePtr())
-            return;
-
-        // update listener position
-        Camera* camera = CameraManager::getInstance().getActiveCamera();
-        if(camera == NULL) return;
-        Vector3 pos = camera->getPosition();
-        alListener3f(AL_POSITION, pos.x, pos.y, pos.z);
+        alListenerfv(AL_POSITION, orient);
         ALenum error = alGetError();
-        if(error == AL_INVALID_VALUE)
-            COUT(2) << "Sound: OpenAL: Invalid listener position" << std::endl;
-
-        // update listener orientation
-        const Quaternion& orient = camera->getOrientation();
-        Vector3 up = orient.xAxis(); // just a wild guess
-        Vector3 at = orient.zAxis();
-
-        ALfloat orientation[6] = { at.x, at.y, at.z,
-                                 up.x, up.y, up.z };
-
-        alListenerfv(AL_POSITION, orientation);
-        error = alGetError();
-        if(error == AL_INVALID_VALUE)
+        if (error == AL_INVALID_VALUE)
             COUT(2) << "Sound: OpenAL: Invalid listener orientation" << std::endl;
-
-        // update sounds
-        for(std::list<SoundBase*>::iterator i = this->soundlist_.begin(); i != this->soundlist_.end(); i++)
-            (*i)->update();
-    }
-
-    /**
-    * Check if sound is available
-    */
-    bool SoundManager::isSoundAvailable()
-    {
-        return this->soundavailable_;
     }
 }
Index: /code/trunk/src/orxonox/sound/SoundManager.h
===================================================================
--- /code/trunk/src/orxonox/sound/SoundManager.h	(revision 5928)
+++ /code/trunk/src/orxonox/sound/SoundManager.h	(revision 5929)
@@ -39,9 +39,8 @@
     /**
      * The SoundManager class manages the OpenAL device, context and listener
-     * position. It has a list of all SoundBase objects and calls their update
-     * function every tick. It is a singleton.
+     * position. It is a singleton.
      *
      */
-    class _OrxonoxExport SoundManager : public Singleton<SoundManager>, public Tickable
+    class _OrxonoxExport SoundManager : public Singleton<SoundManager>
     {
         friend class Singleton<SoundManager>;
@@ -49,18 +48,15 @@
         SoundManager();
         ~SoundManager();
-        void addSound(SoundBase* sound);
-        void removeSound(SoundBase* sound);
-        void tick(float dt);
-        bool isSoundAvailable();
+
+        void setListenerPosition(const Vector3& position);
+        void setListenerOrientation(const Quaternion& orientation);
 
     private:
         ALCdevice* device_;
         ALCcontext* context_;
-        std::list<SoundBase*> soundlist_;
-        bool soundavailable_;
 
         static SoundManager* singletonPtr_s;
-    }; // class SoundManager
-} // namespace orxonox
+    };
+}
 
 #endif /* _SoundManager_H__ */
